import {
    Lighter,
    Darker,
    Black,
    White} from "../../Tools/colors";

export const Model = function(theme) {
    const colors = {
        green: theme.colors.Accessible_Green,
        dark: theme.colors.Cool_Grey_11,
        blue: theme.colors.Accessible_Blue,
        danger: theme.colors.Red,
        white: theme.colors.White,
        black: theme.colors.Black,
    }
    return {
        style: {
            green: {
                primary_loud: {
                    default: {
                        background: colors.green,
                        fontColor: theme.colors.White,
                        borderColor: "transparent"
                    },
                    hover: {
                        background: Darker(colors.green, 0.16),
                        color: theme.colors.White,
                        borderColor: "transparent"
                    },
                    active: {
                        background: Darker(colors.green, 0.24),
                        fontColor: theme.colors.White,
                        borderColor: "transparent"
                    }
                },
                primary: {
                    default: {
                        background: "transparent",
                        fontColor: colors.green,
                        borderColor: colors.green,
                    },
                    hover: {
                        background: Black(0.08),
                        fontColor: Darker(colors.green, 0.32),
                        borderColor: Darker(colors.green, 0.32),
                    },
                    active: {
                        background: Black(0.12),
                        fontColor: Darker(colors.green, 0.48),
                        borderColor: Darker(colors.green, 0.48),
                    }
                },
                primary_inverse: {
                    default: {
                        background: "transparent",
                        fontColor: colors.green,
                        borderColor: colors.green,
                    },
                    hover: {
                        background: White(0.16),
                        fontColor: Lighter(colors.green, 0.32),
                        borderColor: Lighter(colors.green, 0.32),
                    },
                    active: {
                        background: White(0.24),
                        fontColor: Lighter(colors.green, 0.48),
                        borderColor: Lighter(colors.green, 0.48),
                    }
                },
                secondary_loud: {
                    default: {
                        background: colors.dark,
                        fontColor: theme.colors.White,
                        borderColor: "transparent"
                    },
                    hover: {
                        background: Darker(colors.dark, 0.16),
                        color: theme.colors.White,
                        borderColor: "transparent"
                    },
                    active: {
                        background: Darker(colors.dark, 0.24),
                        fontColor: theme.colors.White,
                        borderColor: "transparent"
                    }
                },
                secondary: {
                    default: {
                        background: "transparent",
                        fontColor: colors.dark,
                        borderColor: colors.dark,
                    },
                    hover: {
                        background: Black(0.08),
                        fontColor: Darker(colors.dark, 0.32),
                        borderColor: Darker(colors.dark, 0.32),
                    },
                    active: {
                        background: Black(0.12),
                        fontColor: Darker(colors.dark, 0.48),
                        borderColor: Darker(colors.dark, 0.48),
                    }
                },
                silent: {
                    default: {
                        background: "transparent",
                        fontColor: colors.green,
                        borderColor: "transparent",
                    },
                    hover: {
                        background: Black(0.08),
                        fontColor: Darker(colors.green, 0.32),
                        borderColor: "transparent",
                    },
                    active: {
                        background: Black(0.12),
                        fontColor: Darker(colors.green, 0.48),
                        borderColor: "transparent",
                    }
                },
                silent_inverse: {
                    default: {
                        background: "transparent",
                        fontColor: colors.green,
                        borderColor: "transparent",
                    },
                    hover: {
                        background: White(0.16),
                        fontColor: Lighter(colors.green, 0.32),
                        borderColor: "transparent",
                    },
                    active: {
                        background: White(0.24),
                        fontColor: Lighter(colors.green, 0.48),
                        borderColor: "transparent",
                    }
                }
            },
            blue: {
                primary_loud: {
                    default: {
                        background: colors.blue,
                        fontColor: theme.colors.White,
                        borderColor: "transparent"
                    },
                    hover: {
                        background: Darker(colors.blue, 0.16),
                        color: theme.colors.White,
                        borderColor: "transparent"
                    },
                    active: {
                        background: Darker(colors.blue, 0.24),
                        fontColor: theme.colors.White,
                        borderColor: "transparent"
                    }
                },
                primary: {
                    default: {
                        background: "transparent",
                        fontColor: colors.blue,
                        borderColor: colors.blue,
                    },
                    hover: {
                        background: Black(0.08),
                        fontColor: Darker(colors.blue, 0.32),
                        borderColor: Darker(colors.blue, 0.32),
                    },
                    active: {
                        background: Black(0.12),
                        fontColor: Darker(colors.blue, 0.48),
                        borderColor: Darker(colors.blue, 0.48),
                    }
                },
                primary_inverse: {
                    default: {
                        background: "transparent",
                        fontColor: colors.blue,
                        borderColor: colors.blue,
                    },
                    hover: {
                        background: White(0.16),
                        fontColor: Lighter(colors.blue, 0.32),
                        borderColor: Lighter(colors.blue, 0.32),
                    },
                    active: {
                        background: White(0.24),
                        fontColor: Lighter(colors.blue, 0.48),
                        borderColor: Lighter(colors.blue, 0.48),
                    }
                },
                secondary_loud: {
                    default: {
                        background: colors.dark,
                        fontColor: theme.colors.White,
                        borderColor: "transparent"
                    },
                    hover: {
                        background: Darker(colors.dark, 0.16),
                        color: theme.colors.White,
                        borderColor: "transparent"
                    },
                    active: {
                        background: Darker(colors.dark, 0.24),
                        fontColor: theme.colors.White,
                        borderColor: "transparent"
                    }
                },
                secondary: {
                    default: {
                        background: "transparent",
                        fontColor: colors.dark,
                        borderColor: colors.dark,
                    },
                    hover: {
                        background: Black(0.08),
                        fontColor: Darker(colors.dark, 0.32),
                        borderColor: Darker(colors.dark, 0.32),
                    },
                    active: {
                        background: Black(0.12),
                        fontColor: Darker(colors.dark, 0.48),
                        borderColor: Darker(colors.dark, 0.48),
                    }
                },
                silent: {
                    default: {
                        background: "transparent",
                        fontColor: colors.blue,
                        borderColor: "transparent",
                    },
                    hover: {
                        background: Black(0.08),
                        fontColor: Darker(colors.blue, 0.32),
                        borderColor: "transparent",
                    },
                    active: {
                        background: Black(0.12),
                        fontColor: Darker(colors.blue, 0.48),
                        borderColor: "transparent",
                    }
                },
                silent_inverse: {
                    default: {
                        background: "transparent",
                        fontColor: colors.blue,
                        borderColor: "transparent",
                    },
                    hover: {
                        background: White(0.16),
                        fontColor: Lighter(colors.blue, 0.32),
                        borderColor: "transparent",
                    },
                    active: {
                        background: White(0.24),
                        fontColor: Lighter(colors.blue, 0.48),
                        borderColor: "transparent",
                    }
                }
            },
            dark: {
                primary_loud: {
                    default: {
                        background: colors.black,
                        fontColor: theme.colors.White,
                        borderColor: "transparent"
                    },
                    hover: {
                        background: Lighter(colors.black, 0.16),
                        color: theme.colors.White,
                        borderColor: "transparent"
                    },
                    active: {
                        background: Lighter(colors.black, 0.24),
                        fontColor: theme.colors.White,
                        borderColor: "transparent"
                    }
                },
                primary: {
                    default: {
                        background: "transparent",
                        fontColor: colors.black,
                        borderColor: colors.black,
                    },
                    hover: {
                        background: Black(0.08),
                        fontColor: colors.black,
                        borderColor: colors.black,
                    },
                    active: {
                        background: Black(0.12),
                        fontColor: colors.black,
                        borderColor: colors.black,
                    }
                },
                primary_inverse: {
                    default: {
                        background: "transparent",
                        fontColor: colors.black,
                        borderColor: colors.black,
                    },
                    hover: {
                        background: White(0.16),
                        fontColor: colors.black,
                        borderColor: colors.black
                    },
                    active: {
                        background: White(0.24),
                        fontColor: colors.black,
                        borderColor: colors.black
                    }
                },
                secondary_loud: {
                    default: {
                        background: colors.dark,
                        fontColor: theme.colors.White,
                        borderColor: "transparent"
                    },
                    hover: {
                        background: Darker(colors.dark, 0.16),
                        color: theme.colors.White,
                        borderColor: "transparent"
                    },
                    active: {
                        background: Darker(colors.dark, 0.24),
                        fontColor: theme.colors.White,
                        borderColor: "transparent"
                    }
                },
                secondary: {
                    default: {
                        background: "transparent",
                        fontColor: colors.dark,
                        borderColor: colors.dark,
                    },
                    hover: {
                        background: Black(0.08),
                        fontColor: Darker(colors.dark, 0.32),
                        borderColor: Darker(colors.dark, 0.32),
                    },
                    active: {
                        background: Black(0.12),
                        fontColor: Darker(colors.dark, 0.48),
                        borderColor: Darker(colors.dark, 0.48),
                    }
                },
                silent: {
                    default: {
                        background: "transparent",
                        fontColor: colors.black,
                        borderColor: "transparent",
                    },
                    hover: {
                        background: Black(0.08),
                        fontColor: colors.black,
                        borderColor: "transparent",
                    },
                    active: {
                        background: Black(0.12),
                        fontColor: colors.black,
                        borderColor: "transparent",
                    }
                },
                silent_inverse: {
                    default: {
                        background: "transparent",
                        fontColor: colors.black,
                        borderColor: "transparent",
                    },
                    hover: {
                        background: White(0.16),
                        fontColor: colors.black,
                        borderColor: "transparent",
                    },
                    active: {
                        background: White(0.24),
                        fontColor: colors.black,
                        borderColor: "transparent",
                    }
                }
            },
            white: {
                primary_loud: {
                    default: {
                        background: colors.white,
                        fontColor: colors.black,
                        borderColor: "transparent"
                    },
                    hover: {
                        background: Darker(colors.white, 0.08),
                        fontColor: colors.black,
                        borderColor: "transparent"
                    },
                    active: {
                        background: Darker(colors.white, 0.12),
                        fontColor: colors.black,
                        borderColor: "transparent"
                    }
                },
                primary: {
                    default: {
                        background: "transparent",
                        fontColor: colors.white,
                        borderColor: colors.white,
                    },
                    hover: {
                        background: White(0.16),
                        fontColor: colors.white,
                        borderColor: colors.white,
                    },
                    active: {
                        background: White(0.24),
                        fontColor: colors.white,
                        borderColor: colors.white,
                    }
                },
                primary_inverse: {
                    default: {
                        background: "transparent",
                        fontColor: colors.white,
                        borderColor: colors.white,
                    },
                    hover: {
                        background: Black(0.16),
                        fontColor: colors.white,
                        borderColor: colors.white
                    },
                    active: {
                        background: Black(0.24),
                        fontColor: colors.white,
                        borderColor: colors.white
                    }
                },
                silent: {
                    default: {
                        background: "transparent",
                        fontColor: colors.black,
                        borderColor: "transparent",
                    },
                    hover: {
                        background: Black(0.08),
                        fontColor: colors.black,
                        borderColor: "transparent",
                    },
                    active: {
                        background: Black(0.12),
                        fontColor: colors.black,
                        borderColor: "transparent",
                    }
                },
                silent_inverse: {
                    default: {
                        background: "transparent",
                        fontColor: colors.white,
                        borderColor: "transparent",
                    },
                    hover: {
                        background: Black(0.16),
                        fontColor: colors.white,
                        borderColor: "transparent",
                    },
                    active: {
                        background: Black(0.24),
                        fontColor: colors.white,
                        borderColor: "transparent",
                    }
                },
                secondary_loud: false,
                secondary: false
            },
            danger: {
                primary_loud: {
                    default: {
                        background: colors.danger,
                        fontColor: theme.colors.White,
                        borderColor: "transparent"
                    },
                    hover: {
                        background: Darker(colors.danger, 0.16),
                        color: theme.colors.White,
                        borderColor: "transparent"
                    },
                    active: {
                        background: Darker(colors.danger, 0.24),
                        fontColor: theme.colors.White,
                        borderColor: "transparent"
                    }
                },
                primary: {
                    default: {
                        background: "transparent",
                        fontColor: colors.danger,
                        borderColor: colors.danger,
                    },
                    hover: {
                        background: Black(0.08),
                        fontColor: Darker(colors.danger, 0.32),
                        borderColor: Darker(colors.danger, 0.32),
                    },
                    active: {
                        background: Black(0.12),
                        fontColor: Darker(colors.danger, 0.48),
                        borderColor: Darker(colors.danger, 0.48),
                    }
                },
                primary_inverse: {
                    default: {
                        background: "transparent",
                        fontColor: colors.danger,
                        borderColor: colors.danger,
                    },
                    hover: {
                        background: White(0.16),
                        fontColor: Lighter(colors.danger, 0.32),
                        borderColor: Lighter(colors.danger, 0.32),
                    },
                    active: {
                        background: White(0.24),
                        fontColor: Lighter(colors.danger, 0.48),
                        borderColor: Lighter(colors.danger, 0.48),
                    }
                },
                secondary_loud: {
                    default: {
                        background: colors.dark,
                        fontColor: theme.colors.White,
                        borderColor: "transparent"
                    },
                    hover: {
                        background: Darker(colors.dark, 0.16),
                        color: theme.colors.White,
                        borderColor: "transparent"
                    },
                    active: {
                        background: Darker(colors.dark, 0.24),
                        fontColor: theme.colors.White,
                        borderColor: "transparent"
                    }
                },
                secondary: {
                    default: {
                        background: "transparent",
                        fontColor: colors.dark,
                        borderColor: colors.dark,
                    },
                    hover: {
                        background: Black(0.08),
                        fontColor: Darker(colors.dark, 0.32),
                        borderColor: Darker(colors.dark, 0.32),
                    },
                    active: {
                        background: Black(0.12),
                        fontColor: Darker(colors.dark, 0.48),
                        borderColor: Darker(colors.dark, 0.48),
                    }
                },
                silent: {
                    default: {
                        background: "transparent",
                        fontColor: colors.danger,
                        borderColor: "transparent",
                    },
                    hover: {
                        background: Black(0.08),
                        fontColor: Darker(colors.danger, 0.32),
                        borderColor: "transparent",
                    },
                    active: {
                        background: Black(0.12),
                        fontColor: Darker(colors.danger, 0.48),
                        borderColor: "transparent",
                    }
                },
                silent_inverse: {
                    default: {
                        background: "transparent",
                        fontColor: colors.danger,
                        borderColor: "transparent",
                    },
                    hover: {
                        background: White(0.16),
                        fontColor: Lighter(colors.danger, 0.32),
                        borderColor: "transparent",
                    },
                    active: {
                        background: White(0.24),
                        fontColor: Lighter(colors.danger, 0.48),
                        borderColor: "transparent",
                    }
                }
            }
        },
        size: {
          s: {
             icon: {
                marginLeft: 1.5 * theme.size.atom,
                marginRight: -0.5 * theme.size.atom,
                width: 3.5 * theme.size.atom,
                height: 3.5 * theme.size.atom,
                paddingTop: 0.75 * theme.size.atom,
                paddingRight: 0.75 * theme.size.atom,
                paddingBottom: 0.75 * theme.size.atom,
                paddingLeft: 0.75 * theme.size.atom,
             },
             button: {
                 paddingTop: theme.size.atom,
                 paddingRight: theme.size.atom * 2,
                 paddingBottom: theme.size.atom,
                 paddingLeft: theme.size.atom * 2,
             },
             onlyIcon: {
                icon: {
                    marginLeft: 0,
                    marginRight: 0,
                    width: 3.5 * theme.size.atom,
                    height: 3.5 * theme.size.atom,
                    paddingTop: 0.75 * theme.size.atom,
                    paddingRight: 0.75 * theme.size.atom,
                    paddingBottom: 0.75 * theme.size.atom,
                    paddingLeft: 0.75 * theme.size.atom,
                },
                 button: {
                     paddingTop: theme.size.atom * 1.2,
                     paddingRight: theme.size.atom * 1.5,
                     paddingBottom: theme.size.atom * 1.2,
                     paddingLeft: theme.size.atom * 1.5,
                 }
             },
             font: theme.font.component_label,
          },
          m: {
              icon: {
                  marginLeft: 2.5 * theme.size.atom,
                  marginRight: -0.5 * theme.size.atom,
                  width: 4 * theme.size.atom,
                  height: 4 * theme.size.atom,
                  paddingTop: 0.75 * theme.size.atom,
                  paddingRight: 0.75 * theme.size.atom,
                  paddingBottom: 0.75 * theme.size.atom,
                  paddingLeft: 0.75 * theme.size.atom,
              },
              button: {
                  paddingTop: theme.size.atom * 1.3,
                  paddingRight: theme.size.atom * 3.1,
                  paddingBottom: theme.size.atom * 1.8,
                  paddingLeft: theme.size.atom * 3.1,
              },
              onlyIcon: {
                  icon: {
                      marginLeft: 0,
                      marginRight: 0,
                      width: 4 * theme.size.atom,
                      height: 4 * theme.size.atom,
                      paddingTop: 0.75 * theme.size.atom,
                      paddingRight: 0.75 * theme.size.atom,
                      paddingBottom: 0.75 * theme.size.atom,
                      paddingLeft: 0.75 * theme.size.atom,
                  },
                  button: {
                      paddingTop: theme.size.atom * 1.9,
                      paddingRight: theme.size.atom * 2.45,
                      paddingBottom: theme.size.atom * 2.2,
                      paddingLeft: theme.size.atom * 2.45,
                  },
              },
              offsetTop: theme.size.atom * 1.3,
              offsetRight: theme.size.atom * 3.1,
              offsetBottom: theme.size.atom * 1.8,
              offsetLeft: theme.size.atom * 3.1,
              font: theme.font.body_text,
          },
          l: {
              icon: {
                  marginLeft: 3.5 * theme.size.atom,
                  marginRight: -0.5 * theme.size.atom,
                  width: 4 * theme.size.atom,
                  height: 4 * theme.size.atom,
                  paddingTop: 0.75 * theme.size.atom,
                  paddingRight: 0.75 * theme.size.atom,
                  paddingBottom: 0.5 * theme.size.atom,
                  paddingLeft: 0.75 * theme.size.atom,
              },
              button: {
                  paddingTop: theme.size.atom * 2.3,
                  paddingRight: theme.size.atom * 4.1,
                  paddingBottom: theme.size.atom * 2.7,
                  paddingLeft: theme.size.atom * 4.1,
              },
              onlyIcon: {
                  icon: {
                      marginLeft: 0,
                      marginRight: 0,
                      width: 4 * theme.size.atom,
                      height: 4 * theme.size.atom,
                      paddingTop: 0.75 * theme.size.atom,
                      paddingRight: 0.75 * theme.size.atom,
                      paddingBottom: 0.5 * theme.size.atom,
                      paddingLeft: 0.75 * theme.size.atom,
                  },
                  button: {
                      paddingTop: theme.size.atom * 3,
                      paddingRight: theme.size.atom * 3.5,
                      paddingBottom: theme.size.atom * 3,
                      paddingLeft: theme.size.atom * 3.5,
                  },
              },
              font: theme.font.body_text,
          }
       }
    }
}
