import { Lighter, Darker, Black, White} from "../../Tools/colors";

export const Model = function(theme) {
    const colors = {
        green: theme.colors.Accessible_Green,
        dark: theme.colors.Cool_Grey_11,
        blue: theme.colors.Accessible_Blue,
        danger: theme.colors.Red,
        white: theme.colors.White,
        black: theme.colors.Black,
    }
    return {
        style: {
           green: {
               default: {
                   background: "transparent",
                   borderColor: theme.colors.Black,
                   iconColor: "transparent",
                   fontColor: theme.colors.Black,
               },
               hover: {
                   background: Black(0.16),
                   borderColor: Lighter(colors.black, 0.32),
                   iconColor: "transparent",
                   fontColor: theme.colors.Black,
               },
               selected: {
                   background: colors.green,
                   borderColor: "transparent",
                   iconColor: theme.colors.White,
                   fontColor: theme.colors.Black,
               },
               hover_selected: {
                   background: Darker(colors.green, 0.32),
                   borderColor: "transparent",
                   iconColor: theme.colors.White,
                   fontColor: theme.colors.Black,
               }
           },
           blue: {
               default: {
                   background: "transparent",
                   borderColor: theme.colors.Black,
                   iconColor: "transparent",
                   fontColor: theme.colors.Black,
               },
               hover: {
                   background: Black(0.16),
                   borderColor: Lighter(colors.black, 0.32),
                   iconColor: "transparent",
                   fontColor: theme.colors.Black,
               },
               selected: {
                   background: colors.blue,
                   borderColor: "transparent",
                   iconColor: theme.colors.White,
                   fontColor: theme.colors.Black,
               },
               hover_selected: {
                   background: Darker(colors.blue, 0.32),
                   borderColor: "transparent",
                   iconColor: theme.colors.White,
                   fontColor: theme.colors.Black,
               }
            },
           dark: {
               default: {
                   background: "transparent",
                   borderColor: theme.colors.Black,
                   iconColor: "transparent",
                   fontColor: theme.colors.Black,
               },
               hover: {
                   background: Black(0.16),
                   borderColor: Lighter(colors.black, 0.32),
                   iconColor: "transparent",
                   fontColor: theme.colors.Black,
               },
               selected: {
                   background: theme.colors.Black,
                   borderColor: "transparent",
                   iconColor: theme.colors.White,
                   fontColor: theme.colors.Black,
               },
               hover_selected: {
                   background: Lighter(theme.colors.Black, 0.32),
                   borderColor: "transparent",
                   iconColor: theme.colors.White,
                   fontColor: theme.colors.Black,
               }
            },
           inverse: {
               default: {
                   background: "transparent",
                   borderColor: colors.white,
                   iconColor: "transparent",
                   fontColor: colors.white,
               },
               hover: {
                   background: White(0.16),
                   borderColor: colors.white,
                   iconColor: "transparent",
                   fontColor: colors.white,
               },
               selected: {
                   background: colors.white,
                   borderColor: "transparent",
                   iconColor: colors.black,
                   fontColor: colors.white,
               },
               hover_selected: {
                   background: Darker(colors.white, 0.16),
                   borderColor: "transparent",
                   iconColor: colors.black,
                   fontColor: Darker(colors.white, 0.16)
               }
           },
           error: {
               default: {
                   background: "transparent",
                   borderColor: colors.danger,
                   iconColor: "transparent",
                   fontColor: theme.colors.Black,
               },
               hover: {
                   background: Black(0.16),
                   borderColor: colors.danger,
                   iconColor: "transparent",
                   fontColor: theme.colors.Black,
               },
               selected: {
                   background: colors.danger,
                   borderColor: "transparent",
                   iconColor: theme.colors.White,
                   fontColor: theme.colors.Black,
               },
               hover_selected: {
                   background: Darker(colors.danger, 0.32),
                   borderColor: "transparent",
                   iconColor: theme.colors.White,
                   fontColor: theme.colors.Black,
               }
           },
           error_inverse: {
               default: {
                   background: "transparent",
                   borderColor: colors.danger,
                   iconColor: "transparent",
                   fontColor: theme.colors.White,
               },
               hover: {
                   background: Black(0.16),
                   borderColor: colors.danger,
                   iconColor: "transparent",
                   fontColor: theme.colors.White,
               },
               selected: {
                   background: colors.danger,
                   borderColor: "transparent",
                   iconColor: theme.colors.Black,
                   fontColor: theme.colors.White,
               },
               hover_selected: {
                   background: Darker(colors.danger, 0.32),
                   borderColor: "transparent",
                   iconColor: theme.colors.Black,
                   fontColor: theme.colors.White,
               }
           }
        },
        font: theme.font.body_text,
    }
}
